<template>
    <div>
        <el-card>
            <el-form :inline="true" :model="filterQuery" size="mini">
                <el-row style="width: 100%">
                    <el-form-item class="query-form-item">
                        <el-input v-model="filterQuery.nameCode" placeholder="产品标识DI"></el-input>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <el-input v-model="filterQuery.productsName" placeholder="产品名称"></el-input>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <el-input v-model="filterQuery.batchNo" placeholder="批次号"></el-input>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <el-select
                            v-model="filterQuery.supId"
                            filterable
                            remote
                            clearable="true"
                            reserve-keyword
                            placeholder="请输入供应商名称"
                            :remote-method="findMethod"
                            size="mini"
                            :loading="loading"
                        >
                            <el-option
                                v-for="item in fromOptions"
                                :key="item.companyName"
                                :label="item.companyName"
                                :value="item.customerId"
                            >
                                <span style="float: left">{{ item.companyName }}</span>
                            </el-option>
                        </el-select>
                    </el-form-item>


                </el-row>
                <el-row style="width: 100%">
                    <el-form-item class="query-form-item">
                        <el-input v-model="filterQuery.ggxh" placeholder="规格型号"></el-input>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <el-input v-model="filterQuery.zczbhhzbapzbh" placeholder="批准文号"></el-input>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <el-input v-model="filterQuery.ylqxzcrbarmc" placeholder="生产厂家"></el-input>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <el-input v-model="filterQuery.orderIdFk" placeholder="单据号"></el-input>
                    </el-form-item>
                    <el-form-item>
                        <el-button-group>
                            <el-button
                                type="primary"
                                icon="el-icon-refresh"
                                @click="onReset"
                            ></el-button>
                            <el-button type="primary" icon="search" @click="onSubmit"
                            >查询
                            </el-button
                            >
                            <el-button type="primary" icon="search" @click="clearAll"
                            >清空库存
                            </el-button
                            >
                        </el-button-group>
                    </el-form-item>
                </el-row>

            </el-form>

            <el-table v-loading="loading" :data="list" style="width: 100%">
                <el-table-column label="序号" type="index"></el-table-column>
                <el-table-column label="产品标识" prop="nameCode" width="120"></el-table-column>
                <el-table-column label="产品名称" prop="cpmctymc" width="180">
                </el-table-column>
                <el-table-column label="规格型号" prop="ggxh" width="180"></el-table-column>
                <el-table-column label="批次号" prop="batchNo" width="120"></el-table-column>
                <el-table-column label="生产日期" prop="productionDate" width="120"></el-table-column>
                <el-table-column label="失效日期" prop="expireDate" width="120"></el-table-column>
                <el-table-column label="数量" prop="inCount" width="120"></el-table-column>
                <el-table-column label="生产厂家" prop="ylqxzcrbarmc" v-if="showSup" show-overflow-tooltip
                                 width="120"></el-table-column>

                <el-table-column label="供应商" prop="companyName" v-if="showSup" show-overflow-tooltip
                                 width="120"></el-table-column>
                <!--                <el-table-column label="仓库" prop="invStorageName" v-if="showSup"-->
                <!--                                 show-overflow-tooltip width="120"></el-table-column>-->
                <!--                <el-table-column label="操作" width="120" fixed="right">-->
                <!--                    <template slot-scope="scope">-->
                <!--                        <el-button-->
                <!--                            type="text"-->
                <!--                            size="small"-->
                <!--                            @click.native.stop="intentDetail(scope.row)"-->
                <!--                        >详情-->
                <!--                        </el-button-->
                <!--                        >-->

                <!--                        <el-button-->
                <!--                            type="text"-->
                <!--                            size="small"-->
                <!--                            @click.native.stop="deleteDialog(scope.row.id)"-->
                <!--                        >删除-->
                <!--                        </el-button-->
                <!--                        >-->
                <!--                    </template>-->
                <!--                </el-table-column>-->
            </el-table>
        </el-card>

        <el-dialog
            title="库存详情"
            :visible.sync="codeDetailVisible"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            width="85%"
            v-if="codeDetailVisible"
        >
            <codeDetail
                :idQuery="idQuery"
                v-on:closeDetailDialog="closeDetailDialog"
            ></codeDetail>
        </el-dialog>
        <el-pagination
            :page-size="filterQuery.limit"
            @current-change="handleCurrentChange"
            layout="prev, pager, next"
            :total="total"
            :current-page="filterQuery.page"
        ></el-pagination>
    </div>
</template>

<script>
import {
    filterProducts,
    deleteProducts, clearAllProducts
} from "../../api/inventory/InvPreInProducts";
import draggable from "vuedraggable";
import codeDetail from "./InvPreInProductsDetail";
import store from "../../store";
import {getBussinessType} from "../../api/basic/bussinessType";
import {filterCustomers} from "@/api/auth/customer";


export default {
    data() {
        return {
            filterQuery: {
                cpmctymc: null,
                nameCode: null,
                relIdFk: null,
                batchNo: null,
                page: 1,
                limit: 20,
                customerId: null,
                unitFk: null,
            },
            detailQuery: {
                code: null,
                productIdFk: null,
                page: 1,
                limit: 20,
            },
            list: [],
            fromOptions: [],
            codeDetailVisible: false,
            total: 0,
            loading: true,
            index: null,
            dialogTableVisible: false,
            formLoading: false,
            dialogVisible: false,
            deleteLoading: false,
            busTypes: [],
            idQuery: null,
            showSup: false,
        };
    },
    components: {
        draggable,
        codeDetail,
    },
    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                cpmctymc: null,
                nameCode: null,
                relIdFk: null,
                batchNo: null,
                customerId: null,
                page: 1, unitFk: null,
                limit: 20,
            };
            this.getList();
        },
        onSubmit() {
            this.loading = true;
            this.getList();
        },
        handleSizeChange(val) {
            this.filterQuery.limit = val;
            this.getList();
        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },
        handleUnitClick(row) {
            this.curIndex = row.id;
            this.dialogTableVisible = true;
        },
        closeDetailDialog(val) {
            this.codeDetailVisible = false;
        },

        closeDialog() {
            this.getList();
        },
        getList() {
            this.loading = true;
            this.filterQuery.customerId = store.getters.customerId;
            filterProducts(this.filterQuery)
                .then((response) => {
                    console.log(response)
                    this.loading = false;
                    this.showSup = response.data.showSup;
                    this.list = response.data.list || [];
                    this.total = response.data.total || 0;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },

        deleteOrders(data) {
            this.loading = true;
            let query = {
                id: data,
            }
            deleteProducts(query)
                .then((response) => {
                    if (response.code == 20000) {
                        this.getList();
                        this.$message({
                            type: "success",
                            message: "删除成功！",
                        });
                    } else {
                        this.$message.error(response.message);
                    }

                })
                .catch(() => {
                });
        },

        deleteDialog(rowId) {
            this.$confirm("此操作将永久删除该订单, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    this.deleteOrders(rowId);
                })
                .catch(() => {
                });
        },


        clearAll() {
            this.$confirm("此操作将永久清空所有预验收库存信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    let query = {id: 1};

                    clearAllProducts(query)
                        .then((response) => {
                            if (response.code == 20000) {
                                this.getList();
                                this.$message({
                                    type: "success",
                                    message: "删除成功！",
                                });
                            } else {
                                this.$message.error(response.message);
                            }

                        })


                })
                .catch(() => {
                });
        },
        findMethod(query) {
            this.fromOptions = [];
            let cQuery = {
                key: query,
                customerName: query,

            };
            // getBasicUnitMaintains(cQuery)
            //     .then((response) => {
            //         this.loading = false;
            //         this.fromOptions = response.data.page.list || [];
            //     })
            //     .catch(() => {
            //         this.loading = false;
            //     });
            filterCustomers(cQuery)
                .then((response) => {
                    this.fromOptions = response.data.list || [];
                })
                .catch(() => {
                    this.fromOptions = [];
                });
        },

        intentDetail(row) {

            this.idQuery = row;
            // this.idQuery.supId = null;
            this.idQuery.customerId = null;
            this.codeDetailVisible = true;
        },
        getBusType() {
            let query = {
                enabled: true,
            };
            getBussinessType(query)
                .then((response) => {
                    this.busTypes = response.data.list || [];
                    this.filterQuery.billAction = this.busTypes[0].action;
                    // this.getList();
                })
                .catch(() => {
                });
        },
        getActionName(action) {
            for (let i = 0; i < this.busTypes.length; i++) {
                if (this.busTypes[i].action === action) {
                    return this.busTypes[i].name;
                }
            }
        },
    },
    filters: {
        statusFilterType(status) {
            const statusMap = {
                false: "success",
                true: "danger",
            };
            return statusMap[status];
        },
    },
    mounted() {
        document.body.ondrop = function (event) {
            event.preventDefault();
            event.stopPropagation();
        };
    },
    created() {
        this.findMethod();
        this.getBusType();
        let query = this.$route.query;
        this.filterQuery = Object.assign(this.filterQuery, query);
        this.filterQuery.limit = parseInt(this.filterQuery.limit);
        // 加载表格数据
        this.getList();
    },
};
</script>

<style type="text/scss" lang="scss">
</style>
